<template>
    <div class="type flex-shrink bg-gray-200 m-2 p-4 flex flex-col">
        <div class="headline flex flex-row items-center mb-2 whitespace-no-wrap">
            <div class="flex-grow text-md uppercase"> Project <span v-if="p.name" class="px-2 text-xs bg-gray-500 text-gray-100 mx-2 rounded-full">#{{p.id}}</span> </div>
            <div class="actions">
                <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="save()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/checkmark.svg" />
                    <span v-if="p.id">Save</span>
                    <span v-else>Create</span>
                </button>
                <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="cancel()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/close-solid.svg" />
                    <span>Cancel</span>
                </button>
                <button v-if="p.id" class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="remove()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/trash.svg" />
                    <span>Delete</span>
                </button>
            </div>
        </div>
        <div class="relative bg-white w-full p-2 rounded-lg">
            <div class="flex flex-col md:flex-row items-start">
                <div class="flex-grow w-full flex flex-row items-center">
                    <div class="input flex flex-col items-center mb-1 py-1 px-2 text-sm">
                        <v-swatches v-model="p.properties.color" :swatches="swatches" row-length="5" shapes="circles" show-border></v-swatches>
                    </div>
                    <div class="input w-full flex flex-col items-start mb-1 py-1 px-2 text-sm">
                        <label class="mb-1 font-semibold capitalize truncate">Name</label>
                        <input type="text" v-model="p.name" class="w-full h-8 border rounded-md px-2" />
                    </div>
                </div>
                <div class="input w-full flex flex-col items-start mb-1 py-1 px-2 text-sm self-end">
                    <label class="mb-1 font-semibold capitalize truncate">
                        <input type="checkbox" v-model="p.listing" class="mr-2 leading-tight" />
                        <span class="text-sm">Appear in Project listing</span>
                    </label>
                </div>
            </div>
            <div class="input flex flex-col items-start mb-1 py-1 px-2 text-sm">
                <label class="mb-1 font-semibold capitalize truncate">Label</label>
                <input type="text" v-model="p.label" class="w-full h-8 border rounded-md px-2" />
            </div>
            <div class="flex flex-col md:flex-row mb-1 py-1 px-2">
                <div class="input w-full flex flex-col items-start mr-1 text-sm">
                    <label class="mb-1 font-semibold capitalize truncate">Tags</label>
                    <div class="flex flex-row border shadow-lg w-full overflow-x-auto">
                        <div class="relative flex-grow w-full bg-white mr-1">
                            <table class="relative table-auto w-full">
                                <thead>
                                    <tr class="border-b border-gray-200">
                                        <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase"></th>
                                        <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Key</th>
                                        <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Value</th>
                                        <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase"></th>
                                    </tr>
                                </thead>
                                <tbody class="bg-white overflow-y-auto w-full">
                                    <tr v-for="(tag, index) in p.properties.universe" :key="index" :class="{'bg-gray-100': index % 2 != 0}">
                                        <td class="px-2 py-2 whitespace-no-wrap">
                                            <input type="checkbox" :checked="keyInCommon(tag.key)" v-on:click="toggleCommon(tag.key)" />
                                        </td>
                                        <td class="px-2 py-2 whitespace-no-wrap">
                                            <div class="text-sm leading-5 text-gray-700 whitespace-pre-line w-full">{{tag.key}}</div>
                                        </td>
                                        <td class="px-2 py-2 whitespace-no-wrap">
                                            <div class="text-sm leading-5 text-gray-700 whitespace-pre-line w-full">{{tag.value}}</div>
                                        </td>
                                        <td class="px-2 py-2 whitespace-no-wrap">
                                            <button class="text-pink-500 hover:text-pink-700 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="removeFromUniverse(tag.key)">
                                                <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/trash.svg" />
                                                <span></span>
                                            </button>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                            <div v-if="adding" class="absolute bottom-0 left-0 w-full bg-pink-200">
                                <div class="flex flex-row">
                                    <input type="text" v-model="newkey" placeholder="key" class="p-1 m-1 text-xs w-full" />
                                    <input type="value" v-model="newvalue" placeholder="value" class="p-1 m-1 text-xs w-full" />
                                    <button class="text-pink-800 hover:text-pink-700 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="addToUniverse(newkey, newvalue)">
                                        <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/checkmark.svg" />
                                    </button>
                                </div>
                            </div>
                        </div>
                        <div class="ml-1 border-l border bg-white">
                            <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="addKey()">
                                <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/add-solid.svg" />
                                <span>Add</span>
                            </button>
                            <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="resetTags()">
                                <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/trash.svg" />
                                <span>Reset</span>
                            </button>
                            <ul class="flex flex-col list-none">
                                <li v-for="(tag, index) in p.properties.common" class="bg-pink-200 text-pink-800 rounded-lg px-2 py-1 m-1">
                                    {{tag.key}}
                                </li>
                            </ul>
                        </div>
                    </div>
                </div>
                <div class="input w-full flex flex-col items-start ml-1 text-sm mt-4 md:mt-0" style="min-height: 400px;">
                    <label class="mb-1 font-semibold capitalize truncate">Center</label>
                    <div class="relative flex-grow w-full h-full">
                        <wee-spatial-mini-map v-model="p.properties.center"></wee-spatial-mini-map>
                    </div>
                </div>
            </div>
            <div class="input flex flex-col items-start mb-1 py-1 px-2 text-sm">
                <label class="mb-1 font-semibold capitalize truncate">Description</label>
                <!--
                <vue-markdown class="result-html full-height" :source="p.description" :show="true" :html="true" :breaks="true" :linkify="true" :emoji="true" :typographer="true" :toc="false"></vue-markdown>
                -->
                <textarea type="text" v-model="p.description" class="w-full h-56 border rounded-md px-2 bg-white shadow-inner"></textarea>
            </div>
            <wee-modal ref="updation" :timeout="10000">
                <template v-slot:loading="e">
                    <img src="./pix/infinity-transparent.png" class="block relative mx-auto" />
                    <div class="text-white w-full text-center">
                        Updating Project {{e.data.id}}
                    </div>
                </template>
                <template v-slot:success="e">
                    <div class="block relative mx-auto">
                        <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-up.svg" />
                    </div>
                    <div class="text-white w-full text-center">
                        Successfully updated project {{e.data.id}}
                    </div>
                </template>
                <template v-slot:failure="e">
                    <div class="block relative mx-auto">
                        <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-down.svg" />
                    </div>
                    <div class="text-white w-full text-center">
                        Failed to update project {{e.data.id}} because
                        <div class="text-pink-200">{{e.data.message}}</div>
                    </div>
                </template>
            </wee-modal>
            <wee-modal ref="creation" :timeout="10000">
                <template v-slot:loading="e">
                    <img src="./pix/infinity-transparent.png" class="block relative mx-auto" />
                    <div class="text-white w-full text-center">
                        Creating Project {{e.data.name}}
                    </div>
                </template>
                <template v-slot:success="e">
                    <div class="block relative mx-auto">
                        <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-up.svg" />
                    </div>
                    <div class="text-white w-full text-center">
                        Successfully created project {{e.data.id}}
                    </div>
                </template>
                <template v-slot:failure="e">
                    <div class="block relative mx-auto">
                        <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-down.svg" />
                    </div>
                    <div class="text-white w-full text-center">
                        Failed to create project {{e.data.name}} because
                        <div class="text-pink-200">{{e.data.message}}</div>
                    </div>
                </template>
            </wee-modal>
        </div>
    </div>
</template>
<script>
import Vue from 'vue'
import axios from 'axios'
import vSelect from 'vue-select'
import VSwatches from 'vue-swatches'
import WeeModal from './WeeModal'
import WeeSpatialMiniMap from './WeeSpatialMiniMap'
// import VueMarkdown from 'vue-markdown'
import {themes} from './themes.js';
import 'vue-select/dist/vue-select.css';
import 'vue-swatches/dist/vue-swatches.css'
import './style.css';

Vue.component('v-select', vSelect);

export default {
    name: "WeeSpatialProjectInfo",
    props: ["project"],
    components: {
        // VueMarkdown,
        VSwatches,
        WeeSpatialMiniMap,
        WeeModal
    },
    data(){
        return {
            adding: false,
            p: this.project,
            backup: JSON.stringify(this.project),
            access: [{
                value: 'admin',
                label: 'Admin (Project creator)'
            },{
                value: 'member',
                label: 'Member (Registered user)'
            },{
                value: 'contributor',
                label: 'Contributor (Member of this project)'
            },{
                value: 'anyone',
                label: 'Anyone (Including non-registered visitors)'
            }],
            swatches: Object.keys(themes).map(function(c){
                return {color: c, label: c}
            }),
        };
    },
    watch: {
        project(p){
            this.p = p;
            this.backup = JSON.stringify(p);
        }
    },
    methods: {
        keyInCommon(k){
            return this.p.properties.common.filter(c => c.key == k).length > 0;
        },
        toggleCommon(k){
            if(!this.keyInCommon(k)){
                this.p.properties.common.push({key: k});
            }else{
                const idx = this.p.properties.common.map(c => c.key).indexOf(k);
                this.p.properties.common.splice(idx, 1);
            }
        },
        removeFromUniverse(k){
            const cidx = this.p.properties.common.map(c => c.key).indexOf(k);
            if(cidx >= 0){
                this.p.properties.common.splice(cidx, 1);
            }
            const idx = this.p.properties.universe.map(c => c.key).indexOf(k);
            if(idx >= 0){
                this.p.properties.universe.splice(idx, 1);
            }
        },
        addKey(){
            this.adding = !this.adding;
        },
        addToUniverse(newkey, newvalue){
            const idx = this.p.properties.universe.map(c => c.key).indexOf(newkey);
            if(idx < 0){
                this.p.properties.universe.push({
                    key: newkey,
                    value: newvalue
                });
            }
            this.adding = false;
        },
        cancel(){
            const backup = JSON.parse(this.backup);
            this.p.name = backup.name;
            this.p.label = backup.label;
            this.p.description = backup.description;
            this.resetTags();
        },
        resetTags(){
            this.adding = false;
            const backup = JSON.parse(this.backup);
            this.p.properties.universe = backup.properties.universe;
            this.p.properties.common   = backup.properties.common;
        },
        update(){
            let self = this;
            this.$refs.updation.activate({
                id: this.p.id
            });
            axios.post(this.updateUrl, this.p).then(function(response){
                if(response.data.success){
                    self.$refs.updation.done({
                        id: response.data.id
                    });
                    self.$emit('updated');
                }else{
                    self.$refs.updation.failed({
                        id: self.p.id,
                        message: response.data.message
                    });
                }
            }).catch(function(error){
                self.$refs.updation.failed({
                    id: self.p.id,
                    message: error
                });
            });
        },
        create(){
            let self = this;
            this.$refs.creation.activate({
                id: this.p.name
            });
            axios.post(this.createUrl, this.p).then(function(response){
                if(response.data.success){
                    self.$refs.creation.done({
                        id: response.data.id
                    });
                    self.$emit('created');
                }else{
                    self.$refs.creation.failed({
                        id: self.p.id,
                        message: response.data.message
                    });
                }
            }).catch(function(error){
                self.$refs.creation.failed({
                    id: self.p.name,
                    message: error
                });
            });
        },
        save(){
            if(this.p.id){
                this.update();
            }else{
                this.create();
            }
        }
    },
    computed: {
        createUrl(){
            return '/projects/create/';
        },
        updateUrl(){
            return '/projects/'+this.p.id;
        }
    }
}
</script>
<style>

</style>
